
#include "Gar3D.hpp"

using namespace gar3d;

void drawTree(Gar3D& win, double x, double z);

int main() {
	Gar3D window(1280, 720);
	
	bool planets = true;

	double theta1 = 0;
	double radius1 = 4;
	double theta2 = 0;
	double radius2 = 2;

	window.backgroundColor(black);
	window.lineSize(10);
	
	while (!window.shouldQuit()) {
		if(window.input().buttonPressed(arrow_up)){
			planets = !planets;
		}
		
		if(planets) {
			// Planet Orbit
			window.backgroundColor(black);
			
			window.color(yellow);
			window.drawPrimitive(sphere, positive_z, 0, 0, 0, 2); // sun

			theta1 += window.deltatime();		//	1.0 rad/s
			theta2 += window.deltatime() * 1.9;	//	1.9 rad/s

			window.color(blue);
			window.drawPrimitive(sphere, positive_z, radius1 * cos(theta1), 0, radius1 * sin(theta1), 0.5); // planet 1
			window.color(0.8,0.2,0.25);	//	hot pink
			window.drawPrimitive(sphere, positive_z, radius2 * cos(theta2), 0, radius2 * sin(theta2), 0.35); // planet 2
		}
		
		else {
			// forest
			window.backgroundColor(135.0/255, 191.0/255, 235.0/255); // sky blue
			
			window.color(31./255,138./255,19./255); // grass green
			window.drawPrimitive(plane, positive_y, 0,0,0,10);
			
			drawTree(window, -2.5,-2);
			drawTree(window, -2,2.5);
			drawTree(window, -1,-.5);
			drawTree(window, 0,1);
			drawTree(window, 2,2.5);
		}
		
		window.renderFrame();
	}

	return 0;
}

void drawTree(Gar3D& win, double x, double z) {
	win.color(0.627, 0.322, 0.176); // sienna brown
	win.drawPrimitive(cylinder, positive_y, x, 0.5, z, 0.2, 1, 0.2); // stem
	win.color(0, 0.4, 0.05); // dark forest green
	win.drawPrimitive(cone, positive_y, x, 1.25, z, 1, 1.5, 1); // top
}
