
#include "Timer.h"

Timer::Timer()
	: Timer(Duration(10, TimeUnit::Minute), false, NULL) {}
Timer::Timer(bool recur) 
	: Timer(Duration(10, TimeUnit::Minute), recur, NULL){}
Timer::Timer(Duration timeout)
	: Timer(timeout, false, NULL) {}
Timer::Timer(Duration timeout, bool recur)
	: Timer(timeout, recur, NULL) {}
Timer::Timer(bool recur, void(*act)(void))
	: Timer(Duration(1, TimeUnit::Hour), recur, act) {}
Timer::Timer(Duration timeout, void(*act)(void))
	: Timer(timeout, false, act) {}
Timer::Timer(Duration timeout, bool recur, void(*act)(void)) {
	_timeoutDuration = timeout;
	_recur = recur;
	_timerevent = act;
}
bool Timer::Set(Duration d) {
	return Set(Timepoint() + d, NULL);
}
bool Timer::Set(Duration d, void(*_action)(void)) {
	return Set(Timepoint() + d, _action);
}
bool Timer::Set(Timepoint end) {
	return Set(end, NULL);
}
bool Timer::Set(Timepoint end, void(*_action)(void)) {
	if (Reset(end)) {
		_timerevent = _action;
		return true;
	}
	return false;
}
bool Timer::Reset() {
	return Reset(Timepoint() + _timerDuration);
}
bool Timer::Reset(Duration d) {
	return Reset(Timepoint() + d);
}
bool Timer::Reset(Timepoint end) {
	Timepoint now;
	if (end < now || end > now + _timeoutDuration) {
		return false;
	}
	_timerDuration = end - now;
	_eventTime = end;
	_isSet = true;
	return true;
}
int Timer::Check() {
	Timepoint now;
	if (_isSet) {
		if (now >= _eventTime) {
			if (_recur) {
				while (_eventTime <= now )
				{
					_eventTime += _timerDuration;
				}
			}
			else {
				_isSet = false;
			}
			if (_timerevent != NULL) {
				_timerevent();
			}
			return true;
		}
		else return false;
	}
	else return _ifnotset;
}
int Timer::checkReturnIfNotSet() {
	return _ifnotset;
}
int Timer::checkReturnIfNotSet(int b) {
	return (_ifnotset = b);
}
Duration Timer::timeoutDuration() {
	return _timeoutDuration;
}
Duration Timer::timeoutDuration(Duration d) {
	return (_timeoutDuration = d);
}
void Timer::Cancel() {
	_isSet = false;
}
bool Timer::isSet() {
	return _isSet;
}
bool Timer::recur(bool b) {
	return (_recur = b);
}
bool Timer::recur() {
	return _recur;
}